//+------------------------------------------------------------------+
#property copyright "Copyright  2012,jimstradingmachine"
#define magicNumber 16384
#define NONE   0 
#define UP     1 
#define DOWN   2
extern double    F = 4; // Force period
extern string    separator1 = "------trend settings------";
extern double    MovingPeriod = 3;                // moving period for Wato
extern double    MovingShift  = 3;                // moving shift for Wato
extern double takeProfit      = 60;
extern double stopLoss        = 0;             // do not use s/l
extern double slippage        = 3;
extern int maxTrades          =2;


extern double Lots               = 0.10;        // Value For Lot default.
extern double LotsMinimum        = 0.10;        // Describe Minimum Lot Size On Lose Factor.
extern double LotsMaximum        = 0.10;       // Describe Maximum Lot Size On Profit Factor.
extern double RiskFactor         = 1000;       // Describe Risk level For order.
extern double DecreaseFactor     = 3;          // Describe Lot Decrease Factor For order.

extern string    separator3 = "------position settings------";

extern bool      useUnprofitExit = false;          // exit trade when trade was not in profit in defined amount of bars
extern int       maxUnprofitBars = 5;              // amount of bars not in profit
// EA identifier. Allows for several co-existing EA with different values
extern string nameEA       = "DayTrading";  
double adx;
double adx2; 
double adx3; 
double adx1;
double adx21;
double adx31;
double adx11;
double adx22;
double adx33;
double adxa;
double adxb;
double adxc;

double valb;       
double val;                           //---- Force indicator          
double val2;
double val3;
double val1;
double val21;
double val31;
double val5;                                  
double val25;
double val35;
double val16;
double val26;
double val36;

double ma;
double mae;
double mau;
double maa;
double maee;
double mauu;

double sto;
double rsi;

double adxx; double adxaa; double adxbb; double adxtfh; double adxtfi;   

extern double rsiHV = 70;
extern double rsiLV = 30;
extern double stoHV = 80;
extern double stoLV = 20;



int cnt, ticket;

bool buyBE, sellBE;

double realTP, realSL;

double signal;
double minAllowedLot, lotStep, maxAllowedLot;

int unprofitBars=0;

datetime barTime=0;

double  LastBEntryDetected=0; 
double  LastSEntryDetected=0; 

double delay1=0;
double delay2=0;

int itotal=0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
//++++ These are adjusted for 5 digit brokers.
int     pips2points;    // slippage  3 pips    3=points    30=points
double  pips2dbl;       // Stoploss 15 pips    0.015      0.0150
int     Digits.pips;    // DoubleToStr(dbl/pips2dbl, Digits.pips)
int     init(){                                                
     if (Digits % 2 == 1){      // DE30=1/JPY=3/EURUSD=5 forum.mql4.com/43064#515262
                pips2dbl    = Point*10; pips2points = 10;   Digits.pips = 1;
    } else {    pips2dbl    = Point;    pips2points =  1;   Digits.pips = 0; }
    // OrderSend(... Slippage.Pips * pips2points, Bid - StopLossPips * pips2dbl
//---- These are adjusted for 5 digit brokers.
    /* On ECN brokers you must open first and THEN set stops
    int ticket = OrderSend(..., 0,0,...)
    if (ticket < 0)
       Alert("OrderSend failed: ", GetLastError());
    else if (!OrderSelect(ticket, SELECT_BY_TICKET))
       Alert("OrderSelect failed: ", GetLastError());
    else if (!OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0)
       Alert("OrderModify failed: ", GetLastError());
     */
   
   realSL = pips2dbl*stopLoss;
   realTP = pips2dbl*takeProfit;
   slippage = pips2points;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();                // history orders total
   int    losses=0;                             // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*0.01/RiskFactor,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<LotsMinimum) lot=LotsMinimum;        // Describe Minimum Lot Size On Lose Factor.
   return(lot);                                //  and Controlar.
   if(lot>LotsMaximum) lot=LotsMaximum;        // Describe Maximum Lot Size On Profit Factor And Controlar.
   return(LotsMaximum);                        //  and Controlar.
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   if(IsNewBar())
   {
      if(IsProfitOnBar())
         unprofitBars=0;
      else
         unprofitBars++;
   }
//----get ADX   
   adx=iADX(NULL,0,7,PRICE_WEIGHTED,MODE_OPEN,0);
   adx2=iADX(NULL,0,7,PRICE_CLOSE,MODE_OPEN,0);
   adx3=iADX(NULL,0,7,PRICE_MEDIAN,MODE_OPEN,0);
   adx1=iADX(NULL,5,7,PRICE_WEIGHTED,MODE_MAIN,1);
   adx21=iADX(NULL,5,7,PRICE_CLOSE,MODE_MAIN,1);
   adx31=iADX(NULL,5,7,PRICE_MEDIAN,MODE_MAIN,1);
   adx11=iADX(NULL,15,7,PRICE_WEIGHTED,MODE_MAIN,1);
   adx22=iADX(NULL,15,7,PRICE_CLOSE,MODE_MAIN,1);
   adx33=iADX(NULL,15,7,PRICE_MEDIAN,MODE_MAIN,1);
   adxa=(adx+adx2+adx3);
   adxb=(adx1+adx21+adx31);
   adxc=(adx11+adx22+adx33);
//----get Force Indicator   
   val=iForce(NULL,0,F,MODE_SMA,PRICE_OPEN,0);   
   val2=iForce(NULL,0,F,MODE_SMA,PRICE_OPEN,0);
   val3=iForce(NULL,0,F,MODE_SMA,PRICE_OPEN,0);
   val1=iForce(NULL,0,F,MODE_LWMA,PRICE_WEIGHTED,1);
   val21=iForce(NULL,0,F,MODE_LWMA,PRICE_WEIGHTED,1);
   val31=iForce(NULL,0,F,MODE_LWMA,PRICE_WEIGHTED,1); 
   val5=iForce(NULL,5,F,MODE_SMA,PRICE_OPEN,0);   
   val25=iForce(NULL,5,F,MODE_SMA,PRICE_OPEN,0);
   val35=iForce(NULL,5,F,MODE_SMA,PRICE_OPEN,0);
   val16=iForce(NULL,5,F,MODE_LWMA,PRICE_WEIGHTED,1);
   val26=iForce(NULL,5,F,MODE_LWMA,PRICE_WEIGHTED,1);
   val36=iForce(NULL,5,F,MODE_LWMA,PRICE_WEIGHTED,1);
     
   ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_LWMA,PRICE_WEIGHTED,3);
   mae=iMA(NULL,0,MovingPeriod,MovingShift,MODE_LWMA,PRICE_WEIGHTED,3);
   mau=iMA(NULL,0,MovingPeriod,MovingShift,MODE_LWMA,PRICE_WEIGHTED,3);
   maa=iMA(NULL,0,MovingPeriod,MovingShift,MODE_CLOSE,PRICE_CLOSE,4);
   maee=iMA(NULL,0,5,MovingShift,MODE_CLOSE,PRICE_CLOSE,4);
   mauu=iMA(NULL,0,15,MovingShift,MODE_CLOSE,PRICE_CLOSE,4);   
   
   sto=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   rsi=iRSI(NULL,0,4,PRICE_OPEN,0);
   
   LastBEntryDetected=((Close[1]>ma) && (Volume[0]>Volume[1]) && (ma>maa && mae>maee && mau>mauu) && (val>val1) && (val2>val21) && (val3>val31) && (adxa>adxb && adxb>adxc));
   LastSEntryDetected=((Close[1]<ma) && (Volume[0]>Volume[1]) && (ma<maa && mae<maee && mau<mauu) && (val<val1) && (val2<val21) && (val3<val31) && (adxa<adxb && adxb<adxc));
   
  
  // calculate if MA, Force, and Volume permit  Buy trade   
   if ((Close[1]>ma) && (Volume[0]>Volume[1]) && (ma>maa && mae>maee && mau>mauu) && (val>val1) && (val2>val21) && (val3>val31) && (adxa>adxb && adxb>adxc))
      
   {  
    datetime some_time=LastBEntryDetected;
    int      shift=iBarShift(NULL,PERIOD_M1,some_time);
    Print("shift of bar with open time ",TimeToStr(some_time)," is ",shift);
        if((delay1 == shift) && (sto<stoLV && rsi<rsiLV))
         
            // open now 
            buyBE=true;
    
// Check for BUY entry signal
          {  
           if(stopLoss > 0)
               realSL = Ask - stopLoss * Point;
           if(takeProfit > 0)
               realTP = Ask + takeProfit * Point;
           if(itotal>=maxTrades)
           
              buyBE=false; 
                 
           // Buy
           ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, slippage,0,0, 
                    nameEA, magicNumber,0,Green);           
                            
           if(ticket < 0)
               Print("OrderSend (",nameEA,") failed with error #", GetLastError());
           prtAlert("Day Trading: Buying");
                    OrderModify(ticket,OrderOpenPrice(),realSL, realTP,0,Blue); 
               if(ticket < 0)
               Print("OrderModify (",nameEA,") failed with error #", GetLastError());
           prtAlert("Day Trading: Selling");     
         }
   }

// calculate if MA, Force, and Volume permit  Sell trade
   if ((Close[1]<ma) && (Volume[0]>Volume[1]) && (ma<maa && mae<maee && mau<mauu) && (val<val1) && (val2<val21) && (val3<val31)  && (adxa<adxb && adxb<adxc))
      
   {
    datetime some_time2=LastSEntryDetected;
    int      shift2=iBarShift(NULL,PERIOD_M1,some_time2);
    Print("shift of bar with open time ",TimeToStr(some_time2)," is ",shift2); 
        if((delay2 == shift2) && (sto>stoHV && rsi>rsiHV))
        
          // open now
          sellBE=true;
          
// Check for SELL entry signal    
         {  
           if(stopLoss > 0)
               realSL = Bid + stopLoss * Point;
           if(takeProfit > 0)
               realTP = Bid - takeProfit * Point;
           if(itotal>=maxTrades)
           
             sellBE=false;
                           
           // Sell
           ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, slippage,0,0, 
                              nameEA, magicNumber, 0, Red);                             
                                   
           if(ticket < 0)
               Print("OrderSend (",nameEA,") failed with error #", GetLastError());
           prtAlert("Day Trading: Selling");
           
                    OrderModify(ticket,OrderOpenPrice(),realSL, realTP,0,Blue);
            if(ticket < 0)
               Print("OrderModify (",nameEA,") failed with error #", GetLastError());
           prtAlert("Day Trading: Selling");
                    
         }
     }
   return(0);
  }     

//////////////////////////////////////////////////////////////////////////////////////////////////

{
   int total=OpenTradesForMNandPairType(magicNumber, Symbol());
   for(int cnt=total-1;cnt>=0;cnt--)
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(   OrderType()<=OP_SELL                      // check for opened position 
         && OrderSymbol()==Symbol()                   // check for symbol
         && OrderMagicNumber() == magicNumber)        // my magic number
      {
         if(OrderType()==OP_BUY)   // long position is opened
         {
            // should it be closed?                       
             if(Open[0]>=realSL || Open[0]>=realTP)
            {
               if(OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet)) // close position
               {
                  return (true);
               }
               return(false);
            } 
         }
         else // go to short position
         {
            // should it be closed?        
            if(Open[0]>=realSL || Open[0]>=realTP)
            {
               if(OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet)) // close position
               {
                  return (true);  
               }
               return(false);
            }          
         }
      }
   }
}

///////////////////////////////////////////////////////////////////////////////////////////////////
bool IsNewBar()
{
   if( barTime < Time[0]) 
   {
        // we have a new bar opened
      barTime = Time[0];
      return(true);
   }
   return (false);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
bool IsProfitOnBar()
{
   int icnt, itotal;
   itotal=OrdersTotal();
   if(itotal==0)
      return(true);
      
   for(icnt=itotal-1;icnt>=0;icnt--) // for loop
   {
      OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
      // check for opened position, symbol & MagicNumber
      if (OrderSymbol()== Symbol() && OrderMagicNumber()==magicNumber)
      {
         if (OrderProfit()>0) 
            return(true);             
      } 
   } // for loop 
   return(false);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void prtAlert(string str = "") 
  {
   Print(str);
   Alert(str);
//   SpeechText(str,SPEECH_ENGLISH);
//   SendMail("Subject EA",str);
  }
//+------------------------------------------------------------------+